<?php

//require_once("dbaccess.inc");

class InfoItem extends DbAccess {
	static $t_table = array(
		'title' => '情報メッセージ',
		'name' => 'info_item',
		'fields' => array(
			1 => 'seq',
			2 => 'info_id',
			3 => 'kind',
			4 => 'value',
			5 => 'reg_date',
		),
		"seq" => "seq"
	);

	function __construct($page=0, $limit=0, $order="", $search=array()) {
		parent::DbAccess($page, $limit, $order, $search, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function getData($id, $fields="", $raw=null) {
		return parent::_getData($id, $fields, $raw, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function addData($data, $raw=null) {
		if (!isset($data["reg_date"])) {
			$data["reg_date"] = "now()";
		}
		return parent::_addData($data, $raw, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function updateData($id, $data, $raw=null) {
		return parent::_updateData($id, $data, $raw, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function deleteData($id) {
		return parent::_deleteData($id, self::$t_table["name"], self::$t_table["seq"]);
	}

	static function findData($cond, $fields=null, $raw=null) {
		return parent::_findData($cond, $fields, $raw, self::$t_table["name"], self::$t_table["seq"]);
	}
}
// メッセージ保存
function save_infoitem($id, $infoitem)
{
	// 現在の設定を削除
	$cond["info_id"] = $id;
	$ret = InfoItem::findData($cond);
	if ($ret) {
		foreach ($ret as $val) {
			InfoItem::deleteData($val["seq"]);
		}
	}
	// 新しい情報を保存
	foreach ($infoitem as $key => $val) {
		if (is_array($val)) {
			foreach ($val as $val2) {
				unset($item);
				$item["info_id"] = $id;
				$item["kind"] = $key;
				$item["value"] = $val2;
				InfoItem::addData($item);
			}
		} else {
			unset($item);
			$item["info_id"] = $id;
			$item["kind"] = $key;
			$item["value"] = $val;
			InfoItem::addData($item);
		}
	}
}
// メッセージ取得
function get_infoitem($id)
{
	$item = array();
	$cond["info_id"] = $id;
	$ret = InfoItem::findData($cond);
	if ($ret) {
		foreach ($ret as $val) {
			if (isset($item[$val["kind"]])) {
				$item[$val["kind"]] .= "," . $val["value"];
			} else {
				$item[$val["kind"]] = $val["value"];
			}
		}
	}
	return $item;
}
